;  .
; B     .
;D0 -RxD, D1 - TxD, D6 - RS, D5 - R/W, D4 - E, D2 - adr. latch,
;D3 -  #OE,D7 -  #WE
;  -  
; : 0-2 -   , 3 - #1, 4 - #2
;5 -  , 6 -   "", 7 -   ""
;-----------------------------------------------------------------------
.include "d:\Program Files\Atmel\AVR Studio\Appnotes\8515def.inc"
.include "d:\seagull\Depot\AVR\reader\rus.inc"
;-----------------------------------------------------------------------
.def rsym=r0
.def storel=r1
.def storeh=r2
.def book=r3
.def storead0=r4
.def storead1=r5
.def all_book=r6

.def rus=r14
.def store=r15
.def work=r16
.def data=r17
.def char=r18
.def pauseh=r19
.def pausel=r20
.def count=r21
.def address0=r22
.def address1=r23
.def address2=r24
.def flag=r25
.def key=r26

.def loz=r30
.def hiz=r31
;-----------------------------------------------------------------------
;flag: 0 = 1- ; 1 =1-  2- ; 2 =1 -  
;3 = 1- pop
;-----------------------------------------------------------------------

.set E=4
.set RW=5
.set RS=6
.set C = 2
.set WE=7
.set OE=3
.set CE1=3
.set CE2=4

.equ TSYM=80			;   
;-----------------------------------------------------------------------
.org 0x000

;.org 0x007 
;	rjmp RXcomplete
.org 0x010
main:
	bclr 7			; 
	ldi work, 0x5f		;  
	out spl,work 
	ldi work, 0x02		;   
	out sph,work
	ldi work,0b11111110
	out ddrd, work
	ldi work,0b10001011
	out portd, work
	ser work
	out ddrb, work		; 
	ldi work, 0b00011000	;8- , /, RX-~
	out ucr, work
	ldi work, 4
	out ubrr, work		;115200   9,216 
	ser work
	out ddrc, work		;  
	ldi work, 0b00011111
	out ddra, work		;  A
	clr work
	out portc,work
	ldi work, 0b11111000
	out porta,work
	clr address0
	clr address1
	clr address2
	ser count
	ldi flag,0b00000100
	clr book
;-----------------------------------------------------------------------
;  

;	rjmp tst_loop

	rcall precharge
	ldi char, 0b00111000	;8-. ,2 ,58
	rcall write_cmd
	ldi char, 0b00001100	;. ., -. , -  
	rcall write_cmd
	ldi char, 0b00000110	;  .
	rcall write_cmd
	ldi char, 0b00000001
	rcall write_cmd
	in char,udr
	in char,udr
	in char,udr
;-----------------------------------------------------------------------
; 
tst_loop:
;	ldi char,0x55
;	out eedr,work
;	clr work
;	out eearl,work
;	rcall write_flash
;	rcall module_write
;	rcall inc_addr
;	rcall wait_busy
;	rjmp read_begin
;	rjmp tst_loop
;	rjmp command
;----------------------------------------------------------------------
	ldi hiz,(high(hello*2))
	ldi loz,(low(hello*2))
	rcall message
	rcall push_button
main_menu:
	rcall menu		;: 0- , 1- , 2-   , 3-  
	cpi count,0
	breq read_begin
	cpi count,1
	breq pre_goto_bookmark
	cpi count,2
	breq pre_comp_mes
	ldi hiz,(high(about_develop*2))
	ldi loz,(low(about_develop*2))
	rcall message
	rcall push_button
	rjmp main_menu
pre_goto_bookmark:
	rjmp goto_bookmark
read_begin:
	cbr flag,0x04
	rcall choose_text
	rcall get_address_text_begin
continue_read:
	rcall blank_screen
	rcall show_to_screen
menu_2:
	rcall menu
	rcall sub_string
	cpi count,0
	breq continue_read
	cpi count,1
	breq pre_goto_bookmark
	cpi count,2
	breq set_bookmark
listing_subreturn:
	rcall listing
push_list_page:
	push count
list_page:
	rcall blank_screen
	ser count
read_page:
	rcall read_flash
	mov rus,data
	mov char,data
	rcall write_char
	rcall inc_addr
	cpi count,TSYM-1
	brne read_page
	pop count
	rcall push_button
	cpi key,3
	breq sub_page
	cpi key,2
	breq add_page
	rjmp menu_2
add_page:
	push count
	lsl count
	lsl count
	add address1,count
	brcc no_add_adr2
	inc address2
	cpi address2,0x10
	brlo no_add_adr2
	ser address0
	ser address1
	ldi address2,0x0f
no_add_adr2:
	pop count
	rjmp push_list_page
pre_comp_mes:
	rjmp comp_mes
sub_page:
	push count
	lsl count
	lsl count
	sub address1,count
	brsh no_sub_adr2
	dec address2
	brpl no_sub_adr2
	clr address2
	clr address1
	clr address0
no_sub_adr2:
	pop count
	rjmp push_list_page
read_current:
	rcall show_to_screen
	rjmp read_current
set_bookmark:
	push work
write_current:
	clr work
	out eearh,work
	rcall wait_write_internal_eeprom
	mov work,book
	lsl work
	lsl work
	inc work
	out eearl,work
	out eedr,address2
	rcall write_internal_eeprom
	rcall wait_write_internal_eeprom
	inc work
	out eearl,work
	out eedr,address1
	rcall write_internal_eeprom
	rcall wait_write_internal_eeprom
	inc work
	out eearl,work
	out eedr,address0
	rcall write_internal_eeprom
	pop work
	rjmp continue_read
goto_bookmark:
	sbrc flag,2
	rcall choose_text
	push work
	clr work
	out eearh,work
	mov work,book
	lsl work
	lsl work
	inc work
	out eearl,work
	rcall read_internal_eeprom
	push work
	in work,eedr
	cpi work,0xff
	brne no_return_from_gtb
	ldi hiz,(high(no_bookmark*2))
	ldi loz,(low(no_bookmark*2))
	rcall message
	rcall push_button
	pop work
	pop work
	sbrc flag,0x02
	rjmp main_menu
	rjmp continue_read
no_return_from_gtb:
	mov address2,work
	pop work
	inc work
	out eearl,work
	rcall read_internal_eeprom
	in address1,eedr
	inc work
	out eearl,work
	rcall read_internal_eeprom
	in address0,eedr
	pop work
	cbr flag,0x04
	rjmp continue_read
;-----------------------------------------------------------------------
read_internal_eeprom:
	sbic eecr,eewe			;,     
	rjmp read_internal_eeprom
	sbi eecr,eere
	ret	
wait_write_internal_eeprom:
	sbic eecr,eewe
	rjmp wait_write_internal_eeprom
	ret
write_internal_eeprom:
	sbi eecr,eemwe
	sbi eecr,eewe
	ret	
;-----------------------------------------------------------------------
comp_mes:
	ldi hiz,(high(i_love_my_computer*2))
	ldi loz,(low(i_love_my_computer*2))
	rcall message
loop:	
	sbis usr,rxc
	rjmp loop
	rcall blank_screen
	rcall RXcomplete
	cpi data,0xe5
	breq loop_ex
	cpi data,0x5e
	breq command
	rjmp loop
;-----------------------------------------------------------------------
loop_ex:
	sbis usr,rxc
	rjmp loop_ex
	rcall RXcomplete
	rcall write_char
	rcall confirm
	rjmp loop_ex		;
	
;-----------------------------------------------------------------------
write_char:
	push work
	inc count
	cpi count,TSYM/2
	breq next_row
	cpi count,TSYM
	breq new_screen
send:
	sbrc char,7
	rcall decode
	rcall write_data
	pop work
	ret
next_row:
	mov store,char
	ldi char, 0b11000000
	rcall write_cmd
	mov char,store
	rjmp send
new_screen:
	clr count
	mov store,char
	ldi char, 0b00000001
	rcall write_cmd
	mov char,store
	rjmp send
recognize:
;	inc count
;	cpi char,0xa
;	brge nodig
;	ldi work,0x30
;	add char,work
;	rcall write_char
;	ret
nodig:
;	ldi work,0x37
;	add char,work
;	rcall write_char
;	ret
;-----------------------------------------------------------------------
command:
	sbis usr,rxc
	rjmp command
	rcall RXcomplete
	cpi data,0x10
	breq _module_erase1
	cpi data,0x20
	breq _module_erase2
	cpi data,0x30
	breq _module_write
	cpi data,0x40
	breq _module_read
	cpi data,0x50
	breq _module_address_set
	rjmp command
_module_erase1:
	cbr flag,0x02
	rcall module_erase
	rjmp command
_module_erase2:
	sbr flag,0x02
	rcall module_erase
	rjmp command
_module_write:
	rcall module_write
	rjmp command
_module_read:
	rcall blank_screen
	rcall module_read
	rjmp command
_module_address_set:
	rcall module_address_set
	rjmp command
;-----------------------------------------------------------------------
;  /
write_cmd:
	push work
	rcall wait_busy
	cbi portd,RS
	cbi portd,RW
	out portb,char
	rcall latch
	pop work
	ret

write_data:
	push work
	rcall wait_busy
	sbi portd,RS
	cbi portd,RW
	out portb,char
	rcall latch
	pop work
	ret

wait_busy:
	push char
	clr work
	out ddrb, work		;
	ser work		;   
	out portb,work
	cbi portd,RS
	sbi portd,RW
busy:
	nop
	sbi portd,E
	rcall nop_wait
	in char,pinb
	cbi portd,E
	sbrc char,7
	rjmp busy
	ser work
	out ddrb, work		;
	cbi portd,RS
	pop char
	ret

latch:
	rcall nop_wait
	sbi portd,E
	rcall nop_wait
	cbi portd,E
	ret

nop_wait:
	ldi work, 0x1f
_wait:
	dec work
	brne _wait
	ret

precharge:			;  
	ser work
	out ddrb, work		;
	cbi portd,RS
	cbi portd,RW
	rcall pause
	rcall pause
	rcall pause
	rcall pause
	rcall pause
	rcall ldi30
	rcall pause
	rcall pause
	rcall ldi30
	rcall pause
	rcall pause
	rcall ldi30
	rcall pause
	
ldi30:
	ldi work,0x30
	out portb,work
	rcall latch
	ret
;-----------------------------------------------------------------------
pause:
	clr pauseh
	clr pausel
_pauseh:
	rcall pause_1
	dec pauseh
	brne _pauseh
	ret
pause_1:
	dec pausel
	brne pause_1
	ret
;-----------------------------------------------------------------------
RXcomplete:
	in char,udr
	mov rus,char
	mov data,char
	ret
;-----------------------------------------------------------------------
decode:
	cpi char,0xa8
	breq yob
	cpi char,0xb8
	breq yol
	cbr char,0xc0		;    
	ldi hiz,(high(rus_letters*2))
	ldi loz,(low(rus_letters*2))
	add loz,char
	brcc read_code
	inc hiz
read_code:
	lpm
	mov char,rsym
	ret
yob:
	ldi char,0xa2
	ret
yol:
	ldi char,0xb5
	ret
.cseg
rus_letters:
; 
.db 0x41,0xa0,0x42,0xa1,0xe0,0x45,0xa3,0xa4,0xa5,0xa6,0x4b,0xa7,0x4d,0x48
.db 0x4f,0xa8,0x50,0x43,0x54,0xa9,0xaa,0x58,0xe1,0xab,0xac,0xe2,0xad,0xae
.db 0x62,0xaf,0xb0,0xb1
; 
.db 0x61,0xb2,0xb3,0xb4,0xe3,0x65,0xb6,0xb7,0xb8,0xb9,0xba,0xbb,0xbc,0xbd
.db 0x6f,0xbe,0x70,0x63,0xbf,0x79,0xe4,0x78,0xe5,0xc0,0xc1,0xe6,0xc2,0xc3
.db 0xc4,0xc5,0xc6,0xc7
;-----------------------------------------------------------------------
confirm:
;	sbi usr,txc
wait_txc:
	sbis usr,udre
	rjmp wait_txc
	out udr,rus
	ret
;-----------------------------------------------------------------------
adr_latch:
	sbis portd,WE		; 
	out portb,data
	out portc,address0
	sbi portd,C
	nop
	cbi portd,C
	out portc,address1
	push work
	in work,porta		;    
	cbr work,0x07
	or work,address2
	sbrc address2,3
	rjmp ce2_set
	sbr work,0x10		;CE2
	cbr work,0x08		;CE1
	rjmp ce1_set
ce2_set:
	sbr work,0x08
	cbr work,0x10
ce1_set:
	out porta,work
	pop work
	nop
	sbic portd,WE
	in data,pinb		; 
	sbi porta,CE1		; 
	sbi porta,CE2
	ret
;-----------------------------------------------------------------------
inc_addr:
	clz
	inc address0
	brne ret_inc
	inc address1
	brne ret_inc
	inc address2
	cpi address2,0x10
	brlo ret_inc
	sbr flag,0x01
ret_inc:
	ret
;-----------------------------------------------------------------------
erase_flash:
	cbi portd,WE
	sbi portd,OE
	push work
	ldi work, 0x55
	mov address0,work
	mov address1,work
	clr address2
	sbrc flag,1
	sbr address2,0x08		;   
	ldi data,0xaa
	rcall adr_latch
	ldi work, 0xaa
	mov address0,work
	ldi work, 0x2a
	mov address1,work
	ldi data,0x55
	rcall adr_latch
	ldi work, 0x55
	mov address0,work
	mov address1,work
	ldi data,0x80
	rcall adr_latch
	ldi work, 0x55
	mov address0,work
	mov address1,work
	ldi data,0xaa
	rcall adr_latch
	ldi work, 0xaa
	mov address0,work
	ldi work, 0x2a
	mov address1,work
	ldi data,0x55
	rcall adr_latch
	ldi work, 0x55
	mov address0,work
	mov address1,work
	ldi data,0x10
	rcall adr_latch
	sbi portd,WE
	pop work
	mov store,work
	ldi work,10
wait_10s:			;  10 . , .
	rcall wait_1s
	dec work
	brne wait_10s
	mov work,store
	sbi portd,WE
	ret
;-----------------------------------------------------------------------
read_flash:
	sbi portd,WE
	cbi portd,OE
	push work
	clr work
	out ddrb,work
	rcall adr_latch
	ser work
	out ddrb,work
	pop work
	sbi portd,OE
	ret
;-----------------------------------------------------------------------
write_flash:
	mov store,address0
	mov storel,address1
	mov storeh,address2
	cbi portd,WE
	sbi portd,OE
	push work

	ldi work, 0x55
	mov address0,work
	mov address1,work
	cbr address2,0xf7		;    
	ldi data,0xaa
	rcall adr_latch

	ldi work, 0xaa
	mov address0,work
	ldi work, 0x2a
	mov address1,work
	ldi data,0x55
	rcall adr_latch

	ldi work, 0x55
	mov address0,work
	mov address1,work
	ldi data,0xa0
	rcall adr_latch
	
	mov address0,store
	mov address1,storel
	mov address2,storeh
	mov data,char
	rcall adr_latch

	push char
	rcall data_polling
	pop char
	pop work
	sbi portd,WE
	ret
;-----------------------------------------------------------------------
wait_1s:
	push work
	ldi work,0x47
pause_1s_l:
	rcall pause
	dec work
	brne pause_1s_l
	pop work
	ret
;-----------------------------------------------------------------------
module_write:
	clr work
	clr book
	clr address0
	clr address1
	clr address2
find_empty_slot:
	rcall read_flash
	cpi data,0x5e
	brne empty_slot
	rcall inc_addr
	inc book
	mov work,book
	cpi work,0x08
	brne find_empty_slot
	ldi hiz,(high(no_slot*2))
	ldi loz,(low(no_slot*2))
	rcall message
	rcall push_button
	ret
empty_slot:
	ldi char,0x5e
	rcall write_flash
	ldi hiz,(high(type_header*2))
	ldi loz,(low(type_header*2))
	rcall message
	clr address2
	clr address1
	ldi address0,0x0b	;=8 + =3
	mov work,book
	sbrc work,0
	sbr address0,0x40
	sbrc work,1
	sbr address0,0x80
	sbrc work,2
	sbr address1,0x01
	ldi work,55
ret_enter_name:
	sbis usr,rxc
	rjmp ret_enter_name
	rcall RXcomplete
	rcall write_flash 
	rcall inc_addr
	dec work
	breq stop_write_header
	cpi char,0x07
	brne ret_enter_name
	rjmp type_status_reciev
stop_write_header:
	ldi char,0x07
	rcall write_flash 
type_status_reciev:
	ldi hiz,(high(reciev_file*2))
	ldi loz,(low(reciev_file*2))
	rcall message
	rcall get_address_text_begin
module_write_cont:
	sbis usr,rxc
	rjmp module_write_cont
	rcall RXcomplete
	cpi char,0x07
	breq ret_module_write
	mov data,char
	rcall write_flash
	rcall confirm
	rcall inc_addr
	sbrs flag,0		;  .
	rjmp module_write_cont
	ldi hiz,(high(memory_full*2))
	ldi loz,(low(memory_full*2))
	rcall message
	rcall push_button
	ret
ret_module_write:
	mov char,address2
	mov storead1,address1
	mov storead0,address0
	clr address2
	clr address1
	ldi address0,0x08
	mov work,book
	sbrc work,0
	sbr address0,0x40
	sbrc work,1
	sbr address0,0x80
	sbrc work,2
	sbr address1,0x01
	rcall write_flash
	rcall inc_addr
	mov char,storead1
	rcall write_flash
	rcall inc_addr
	mov char,storead0
	rcall write_flash
	ldi hiz,(high(file_recieved*2))
	ldi loz,(low(file_recieved*2))
	rcall message
	ret
;-----------------------------------------------------------------------
module_read:
;	clr address0
;	clr address1
;	clr address2
show_to_screen:
	rcall read_flash
	mov rus,data
	mov char,data
	rcall write_char
	rcall inc_addr
	cpi count,TSYM-1
	breq branch
	rjmp show_to_screen
branch:
	rcall push_button
	cpi key,1
	breq ret_module_read
	cpi key,2
	breq show_to_screen
minus_tsym:
	subi address0,low(TSYM*2)
	sbci address1,high(TSYM*2)
	brsh show_to_screen
	dec address2
	brpl show_to_screen
	clr address0
	clr address1
	clr address2
	rjmp show_to_screen
ret_module_read:
	ret
;-----------------------------------------------------------------------
module_erase:
	clr work		;    
	clr count
	out eearh,work
	rcall wait_write_internal_eeprom
	ldi work,0x01
erase_bookmark:
	out eearl,work
	ser data
	out eedr,data
	rcall write_internal_eeprom
	rcall wait_write_internal_eeprom
	subi work,0xfc
	inc count
	cpi count,8
	brne erase_bookmark
	ldi hiz,(high(memory_erased_process*2))
	ldi loz,(low(memory_erased_process*2))
	rcall message
	rcall erase_flash
	ldi hiz,(high(memory_erased*2))
	ldi loz,(low(memory_erased*2))
	rcall message
	ret
;-----------------------------------------------------------------------
; .  : 1- , 2- , 3- 
push_button_no_wait:
	push work
	clr key
	sbis pina,5
	rjmp red
	sbis pina,6
	rjmp green_down
	sbis pina,7
	rjmp green_up		;ݪ   ,
	ret			;    
push_button:
;	ret
	push work
	clr key
wait_push_button:
	clr work
	sbis pina,5
	rjmp red
	sbis pina,6
	rjmp green_down
	sbis pina,7
	rjmp green_up
	rjmp wait_push_button	;:  
red:
	dec work
	nop
	breq pull_red
	sbis pina,5
	rjmp red
	rjmp wait_push_button
clr_pull_red:
	clr work
pull_red:
	dec work
	nop
	breq red_quit
	sbic pina,5
	rjmp pull_red
	rjmp clr_pull_red
red_quit:
	pop work
	ldi key,1
	ret
green_down:
	dec work
	nop
	breq pull_green_down
	sbis pina,6
	rjmp green_down
	rjmp wait_push_button
clr_pull_green_down:
	clr work
pull_green_down:
	dec work
	nop
	breq green_down_quit
	sbic pina,6
	rjmp pull_green_down
	rjmp clr_pull_green_down
green_down_quit:
	pop work
	ldi key,2
	ret
green_up:
	dec work
	nop
	breq pull_green_up
	sbis pina,7
	rjmp green_up
	rjmp wait_push_button
clr_pull_green_up:
	clr work
pull_green_up:
	dec work
	nop
	breq green_up_quit
	sbic pina,7
	rjmp pull_green_up
	rjmp clr_pull_green_up
green_up_quit:
	pop work
	ldi key,3
	ret
;-----------------------------------------------------------------------
blank_screen:
	ser count
	ldi char, 0b00000001
	rcall write_cmd
	ret
;-----------------------------------------------------------------------
message:
;	ret
	push work
	sbr flag,0x08
	rcall blank_screen
message_loop:
	lpm
	mov work,rsym
	cpi work,0x0
	breq go_away
	cpi work,0x1
	brne no_return
	ldi char, 0b11000000
	rcall write_cmd
	rjmp message_adr_inc
no_return:
	mov char,work
	push loz
	push hiz
	rcall write_data
	pop hiz
	pop loz
message_adr_inc:
	inc loz
	brne message_loop
	inc hiz
	rjmp message_loop
go_away:
	sbrc flag,3
	pop work
	cbr flag,0x08
	ret
; . AVR Studio     ,    .
hello:
.db ' ',bS,_i,_s,_t,_e,_m,_a,' ',' ','"',bK,_n,_i,_g,_o,_ch,_e,_j,'"',0x01,' ',bV,_e,_r,_s,_i,_ya,' ','1','.','3','7',0x00
begin:
.db ' ',bN,_a,_ch,_a,_t,_q,' ',_ch,_i,_t,_a,_t,_q,' ',_k,_n,_i,_g,_u,0x01,0x00
ret_cursor:
.db 0x7e,0x00
zakladka:
.db ' ',bD,_o,_s,_t,_a,_t,_q,' ',_z,_a,_k,_l,_a,_d,_k,_u,0x01,0x00
about:
.db ' ',bR,_e,_a,_l,_i,_z,_o,_v,_a,_n,_o,'.','.','.',0x0
about_develop:
.db ' ','R','&','D',' ','7','-',_ya,' ',bZ,_a,_s,_t,_a,_v,_a,'.',' ',bS,_o,_z,_d,_a,_l,' ','S','e','a','G','u','l','l','.',0x01,' ',bE,_s,_l,_i,' ',_ch,_t,_o,',',' ',_p,_i,_sh,_i,_t,_e,' ',_n,_a,' ','"','s','e','a','g','u','l','l','@','m','a','i','l','.','r','u','"',0x00
computer:
.db ' ',bS,_v,_ya,_z,_a,_t,_q,_s,_ya,' ',_s,' ',bEE,bV,bM,0x01,0x00
i_love_my_computer:
.db ' ',bZH,_d,_u,' ',_s,_v,_ya,_z,_i,' ',_n,_a,' ','1','1','5','2','0','0',0x01,' ',bP,_o,_d,_k,_l,_yu,_ch,_i,_t,_e,' ',_p,_o,_r,_t,'.',0x00
continue:
.db ' ',bP,_r,_o,_d,_o,_l,_zh,_i,_t,_q,' ',_ch,_i,_t,_a,_t,_q,0x01,0x00
pop_zakl:
.db ' ',bP,_o,_l,_o,_zh,_i,_t,_q,' ',_z,_a,_k,_l,_a,_d,_k,_u,0x01,0x00
high_inc:
.db ' ',bL,_i,_s,_t,_a,_t,_q,0x01,0x00
memory_erased:
.db ' ',bP,_a,_m,_ya,_t,_q,' ',_s,_t,_yo,_r,_t,_a,'!',0x00
list_kb:
.db ' ',bV,_v,_e,_d,_i,_t,_e,' ',_sh,_a,_g,' ',_p,_r,_o,_l,_i,_s,_t,_y,_v,_a,_n,_i,_ya,0x01,' ','(',_v,' ',_t,_y,_s,_ya,_ch,_a,_h,' ',_s,_i,_m,_v,_o,_l,_o,_v,')',':',0x00
address_set:
.db ' ',bA,_d,_r,_e,_s,' ',_v,_y,_s,_t,_a,_v,_l,_e,_n,0x00
memory_erased_process:
.db ' ',bS,_t,_i,_r,_a,_yu,'.','.','.',0x00
reciev_file:
.db ' ',bP,_r,_i,_yo,_m,' ',_i,_n,_f,_o,_r,_m,_a,_ts,_i,_i,0x00
file_recieved:
.db ' ',bI,_n,_f,_o,_r,_m,_a,_ts,_i,_ya,' ',_p,_r,_i,_n,_ya,_t,_a,'!',0x00
no_text:
.db ' ',bK,_n,_i,_g,_i,' ',_n,_e,' ',_b,_y,_l,_i,' ',_z,_a,_p,_i,_s,_a,_n,_y,'!',0x00
no_slot:
.db ' ',bN,_e,_t,' ',_m,_e,_s,_t,_a,' ',_v,' ',_t,_a,_b,_l,_i,_ts,_e,' ',_p,_o,_d,' ',_k,_n,_i,_g,_u,'!',0x01,' ',bK,_n,_i,_g,' ',_n,_e,' ',_b,_o,_l,_q,_sh,_e,' ','8','-',_m,_i,'!',0x00
type_header:
.db ' ',bV,_s,_t,_u,_ch,_i,_t,_e,' ',_z,_a,_g,_o,_l,_O,_v,_o,_k,'.',0x00
memory_full:
.db ' ',bP,_a,_m,_ya,_t,_q,' ',_z,_a,_p,_o,_l,_n,_e,_n,_a,' ',_p,_o,_l,_n,_o,_s,_t,_q,_yu,'!',0x00
no_bookmark:
.db ' ',bZ,_a,_k,_l,_a,_d,_k,_a,' ',_d,_l,_ya,' ',_ee,_t,_o,_j,' ',_k,_n,_i,_g,_i,' ',_o,_t,_s,_u,_t,_s,_t,_v,_u,_e,_t,'!',0x00
;-----------------------------------------------------------------------
menu:
;	ret
	clr count
choose_menu:
	sbrs flag,2
	rjmp current
ring_menu:
	push count
	rcall blank_screen
	pop count
	cpi count,2
	breq start_pos_1
	cpi count,3
	breq start_pos_2
start_pos_0:
	cpi count,0
	brne end_pos_01
	rcall show_cur
	rjmp end_pos_02
end_pos_01:
	rcall show_space
end_pos_02:
	ldi hiz,(high(begin*2))
	ldi loz,(low(begin*2))
	rcall message_loop
start_pos_1:
	cpi count,1
	brne end_pos_11
	rcall show_cur
	rjmp end_pos_12
end_pos_11:
	rcall show_space
end_pos_12:
	ldi hiz,(high(zakladka*2))
	ldi loz,(low(zakladka*2))
	rcall message_loop
	cpi count,2
	brlo polling
start_pos_2:
	cpi count,2
	brne end_pos_21
	rcall show_cur
	rjmp end_pos_22
end_pos_21:
	rcall show_space
end_pos_22:
	ldi hiz,(high(computer*2))
	ldi loz,(low(computer*2))
	rcall message_loop
	cpi count,2
	breq polling
start_pos_3:
	cpi count,3
	brne end_pos_31
	rcall show_cur
	rjmp end_pos_32
end_pos_31:
	rcall show_space
end_pos_32:
	ldi hiz,(high(about*2))
	ldi loz,(low(about*2))
	rcall message_loop
polling:
	rcall push_button
	cpi key,2
	breq add_count	
	cpi key,3
	breq sub_count	
	ret
add_count:
	cpi count,3
	breq choose_menu
	inc count
	rjmp choose_menu
sub_count:
	cpi count,0
	breq choose_menu
	dec count
	rjmp choose_menu
;,   
current:
	push count
	rcall blank_screen
	pop count
	cpi count,2
	breq start_cur_1
	cpi count,3
	breq start_cur_2
start_cur_0:
	cpi count,0
	brne end_cur_01
	rcall show_cur
	rjmp end_cur_02
end_cur_01:
	rcall show_space
end_cur_02:
	ldi hiz,(high(continue*2))
	ldi loz,(low(continue*2))
	rcall message_loop
start_cur_1:
	cpi count,1
	brne end_cur_11
	rcall show_cur
	rjmp end_cur_12
end_cur_11:
	rcall show_space
end_cur_12:
	ldi hiz,(high(zakladka*2))
	ldi loz,(low(zakladka*2))
	rcall message_loop
	cpi count,2
	brlo polling
start_cur_2:
	cpi count,2
	brne end_cur_21
	rcall show_cur
	rjmp end_cur_22
end_cur_21:
	rcall show_space
end_cur_22:
	ldi hiz,(high(pop_zakl*2))
	ldi loz,(low(pop_zakl*2))
	rcall message_loop
	cpi count,2
	breq polling
start_cur_3:
	cpi count,3
	brne end_cur_31
	rcall show_cur
	rjmp end_cur_32
end_cur_31:
	rcall show_space
end_cur_32:
	ldi hiz,(high(high_inc*2))
	ldi loz,(low(high_inc*2))
	rcall message_loop
	rjmp polling
show_cur:
	ldi hiz,(high(ret_cursor*2))
	ldi loz,(low(ret_cursor*2))
	rcall message_loop
	ret
show_space:
	ldi char,' '
	rcall write_data
	ret
;-----------------------------------------------------------------------
listing:
	push work
	rcall blank_screen
	ldi count,1
	ldi hiz,(high(list_kb*2))
	ldi loz,(low(list_kb*2))
	rcall message_loop
select_kbyte:
	ldi char, 0b11010111
	rcall write_cmd
	cpi count,0x0a
	brsh big_gid
	mov work,count
	rcall dec_itoa
	ldi char,' '
	rcall write_data
	rjmp after_show
big_gid:
	ldi char,'1'
	push count
	rcall write_data
	pop count
	ldi char, 0b11011000
	rcall write_cmd
	mov work,count
	subi work,0x0a
	rcall dec_itoa
after_show:
	rcall push_button
	cpi key,3
	breq inc_kbyte
	cpi key,2
	breq dec_kbyte
	pop work
	ret
inc_kbyte:
	cpi count,16
	breq select_kbyte
	inc count
	rjmp select_kbyte
dec_kbyte:
	cpi count,1
	breq select_kbyte
	dec count
	rjmp select_kbyte
dec_itoa:
	ldi char,0x30
	add char,work			;      subi!
	push count
	rcall write_data
	pop count
	ret
;-----------------------------------------------------------------------
module_address_set:
	sbis usr,rxc
	rjmp module_address_set
	rcall RXcomplete
	mov address2,data
wait1:
	sbis usr,rxc
	rjmp wait1
	rcall RXcomplete
	mov address1,data
wait2:
	sbis usr,rxc
	rjmp wait2
	rcall RXcomplete
	mov address0,data
	ldi hiz,(high(address_set*2))
	ldi loz,(low(address_set*2))
	rcall message
	ret
;-----------------------------------------------------------------------
get_address_text_begin:
	push work
	mov work,book
	cpi work,0
	brne address_calc
	clr address2
	ldi address1,0x02
	ldi address0,0x08
	rjmp end_get_address_text_begin
address_calc:
	dec work		;  dec book!
	clr address1
	ldi address0,0x08
;	mov work,book
	sbrc work,0
	sbr address0,0x40
	sbrc work,1
	sbr address0,0x80
	sbrc work,2
	sbr address1,0x01
	rcall read_flash
	mov storeh,data
	rcall inc_addr
	rcall read_flash
	mov storel,data
	rcall inc_addr
	rcall read_flash
	mov address0,data
	mov address1,storel
	mov address2,storeh
end_get_address_text_begin:
	pop work
	ret
;-----------------------------------------------------------------------
choose_text:
	push work
	clr address0
	clr address1
	clr address2
	rcall read_flash
	cpi data,0x5e
	breq calk_name
	ldi hiz,(high(no_text*2))
	ldi loz,(low(no_text*2))
	rcall message
	rcall push_button
	rjmp choose_text_ret
calk_name:
	inc address0		; ,   inc_addr
	rcall read_flash
	cpi data,0x5e
	breq calk_name
	dec address0
	mov all_book,address0
show_name:
	clr address1
	ldi address0,0x0b	;=8 + =3
	mov work,book
	sbrc work,0
	sbr address0,0x40
	sbrc work,1
	sbr address0,0x80
	sbrc work,2
	sbr address1,0x01
	rcall blank_screen
	ser count
	mov work,all_book
	cpi work,0
	breq one_book
	cp work,book
	breq book_down
	ldi char,0xda
	rcall write_data
	inc count
	mov work,book
	cpi work,0
	breq one_book
book_down:
	ldi char,0xd9
	rcall write_data
	inc count
one_book:
	ldi char,' '
	rcall write_char
	ldi work,55
name_loop:
	rcall read_flash
	cpi data,0x07
	breq end_show_name_ent
	push work
	mov char,data
	rcall write_char
	rcall inc_addr 
	pop work
	dec work
	brne name_loop
end_show_name_ent:
	ldi char,' '
	rcall write_char
	ldi char,0x7e
	rcall write_char
end_show_name:
	rcall push_button
	cpi key,3		;   
	breq minus_text
	cpi key,2		;   
	breq plus_text
	rjmp choose_text_ret
minus_text:
	mov work,book
	cpi work,0
	breq end_show_name
	dec book
	clr address2
	clr address1
	mov address0,book
	rcall read_flash
	cpi data,0x5e
	breq ret_minus_text
	inc book
ret_minus_text:
	rjmp show_name
plus_text:
	mov work,book
	cpi work,7
	breq end_show_name
	inc book
	clr address2
	clr address1
	mov address0,book
	rcall read_flash
	cpi data,0x5e
	breq ret_plus_text
	dec book
ret_plus_text:
	rjmp show_name
choose_text_ret:
	pop work
	ret
;-----------------------------------------------------------------------
sub_string:
	subi address0,low(TSYM)
	sbci address1,high(TSYM)
	brsh ret_sub_string
	dec address2
ret_sub_string:
	ret
;-----------------------------------------------------------------------
data_polling:
	clr work
	out ddrb,work
	sbi portd,WE
	sbrc address2,3
	rjmp ce2_pol
	sbi porta,CE2		;CE2
	cbi porta,CE1		;CE1
	rjmp repeat_dp
ce2_pol:
	sbi porta,CE1
	cbi porta,CE2
repeat_dp:
	cbi portd,OE
	nop
	nop
	in data,pinb
	sbi portd,OE
	cbr data,0x7f
	cbr char,0x7f
	cp data,char
	brne repeat_dp		; ,    #data polling  7- 
	ser work
	out ddrb,work
	sbi porta,CE1
	sbi porta,CE2
	ret
;-----------------------------------------------------------------------
